
;
; D e f i n e s 
;

SHORTYEAR		equ	'2','0','0','2'
YEAR			equ	'1995-2002'

version 		equ	'v1.57' ; have to be 5 letters long

CURRENT_HEXIT_VERSION   equ     0138h   ; the versionnumber in hex
					; bits 15-8: high version
					; bits	7-0: low version

MAXROWS 		equ	256	; max #rows on screen (e.g 80x60)

MAXFILES		equ	100
MAXWINDOWS		equ	2
MAXFILENAMELENGTH	equ	128	; you can't just change this...
maxcolumn		equ	999
MAXMENUFIELDBUFFERSIZE	equ	256
MAXMENUNUMBERBUFFERSIZE equ	64

SIZEOF_KEYS		EQU	8

MAXKEYS 		EQU	303	; DON'T change this number!
					; you'll have to create a new
					; keysection in the configfile if
					; you wish to allow more keys in
					; the future.

MAX_KEYNAMESIZE 	EQU	44	; maximum length of a key-name, e.g
					; '<Shift>+<Ctrl>+<Alt>+<BackSpace>+<BackSpace>'
					; = 44

MAX_OFFSETS		EQU	16	; max number of offsets in offsetstack

MAX_SEARCHLIST		EQU	1024	; used in the replace routine

MAX_KEYSINBUFFER	EQU	1024	; must be a power of 2

MAX_LINEOFFSETS         EQU     10000    ; used in textmode


;
;
; Define pmode-shipped functions to be included

; --- FILE.ASM

CREATEFILE	EQU	1
OPENFILE	EQU	1
CLOSEFILE	EQU	1
DELETEFILE	EQU	1
LSEEKFILE	EQU	1
FILESIZE	EQU	1
READFILE	EQU	1
WRITEFILE	EQU	1
;FILECOPY	 EQU	 1
;FINDFILE	 EQU	 1


;
;
; Values used in ARGC.ASM

ARG_STR 	EQU	0	; string argument
ARG_SWI 	EQU	1	; standalone switch
ARG_SVAL	EQU	2	; switch followed by a value
ARG_SSTR	EQU	3	; switch followed by a string

SWI_FILE	EQU	0
SWI_WIN 	EQU	1
SWI_VM		EQU	2
SWI_SS		EQU	3
SWI_O		EQU	4
SWI_DASHDASH	EQU	-1


;
;
; Misc defines

DA_SEGSIZE16	EQU	0
DA_SEGSIZE32	EQU	1

; Item types

ITEM_SSCANCODE		EQU	1	; Sel.	 Scancode only
ITEM_NSCANCODE		EQU	2	; NoSel. Scancode only
ITEM_STEXT		EQU	3	; Sel.	 Text
ITEM_NTEXT		EQU	4	; NoSel. Text
ITEM_SSTRING		EQU	5	; Sel.	 Text w/ string
ITEM_NSTRING		EQU	6	; NoSel. Text w/ string
ITEM_SNUMBER		EQU	7	; Sel.	 Text w/ number
ITEM_NNUMBER		EQU	8	; NoSel. Text w/ number
ITEM_SCOMBO		EQU	9	; Sel.	 Text w/ combobox
ITEM_NCOMBO		EQU	10	; NoSel. Text w/ combobox
ITEM_SCHK		EQU	11	; Sel.	 Text w/ checkbox
ITEM_NCHK		EQU	12	; NoSel. Text w/ checkbox
ITEM_DUMMY		EQU	13	; Dummy (don't use this!)
ITEM_CTEXT		EQU	14	; Common text (no item!)
ITEM_SHEXSTRING 	EQU	15	; Sel.	 Text w/ HEX string
ITEM_NHEXSTRING 	EQU	16	; NoSel. Text w/ HEX string

; Values for AL after int 16,2

SHIFTKEY_NONE		EQU	0

SHIFTKEY_SHIFT		EQU	3
SHIFTKEY_CTRL		EQU	4
SHIFTKEY_ALT		EQU	8

; Scancodes for various keys

KEY_NONE		EQU	0

KEY_ESC 		EQU	1

KEY_HOME		EQU	71
KEY_END 		EQU	79
KEY_LEFT		EQU	75
KEY_RIGHT		EQU	77
KEY_UP			EQU	72
KEY_DOWN		EQU	80
KEY_PAGEUP		EQU	73
KEY_PAGEDOWN		EQU	81

KEY_CTRL_HOME		EQU	119
KEY_CTRL_END		EQU	117
KEY_CTRL_LEFT		EQU	115
KEY_CTRL_RIGHT		EQU	116
KEY_CTRL_UP		EQU	141
KEY_CTRL_DOWN		EQU	145
KEY_CTRL_PAGEUP 	EQU	132
KEY_CTRL_PAGEDOWN	EQU	118

KEY_ALT_HOME		EQU	151
KEY_ALT_END		EQU	159
KEY_ALT_LEFT		EQU	155
KEY_ALT_RIGHT		EQU	157
KEY_ALT_UP		EQU	152
KEY_ALT_DOWN		EQU	160
KEY_ALT_PAGEUP		EQU	153
KEY_ALT_PAGEDOWN	EQU	161

KEY_F1			EQU	59
KEY_F2			EQU	60
KEY_F3			EQU	61
KEY_F4			EQU	62
KEY_F5			EQU	63
KEY_F6			EQU	64
KEY_F7			EQU	65
KEY_F8			EQU	66
KEY_F9			EQU	67
KEY_F10 		EQU	68
KEY_F11 		EQU	133
KEY_F12 		EQU	134

KEY_SHIFT_F1		EQU	84
KEY_SHIFT_F2		EQU	85
KEY_SHIFT_F3		EQU	86
KEY_SHIFT_F4		EQU	87
KEY_SHIFT_F5		EQU	88
KEY_SHIFT_F6		EQU	89
KEY_SHIFT_F7		EQU	90
KEY_SHIFT_F8		EQU	91
KEY_SHIFT_F9		EQU	92
KEY_SHIFT_F10		EQU	93
KEY_SHIFT_F11		EQU	135
KEY_SHIFT_F12		EQU	136

KEY_CTRL_F1		EQU	94
KEY_CTRL_F2		EQU	95
KEY_CTRL_F3		EQU	96
KEY_CTRL_F4		EQU	97
KEY_CTRL_F5		EQU	98
KEY_CTRL_F6		EQU	99
KEY_CTRL_F7		EQU	100
KEY_CTRL_F8		EQU	101
KEY_CTRL_F9		EQU	102
KEY_CTRL_F10		EQU	103
KEY_CTRL_F11		EQU	137
KEY_CTRL_F12		EQU	138

KEY_ALT_F1		EQU	104
KEY_ALT_F2		EQU	105
KEY_ALT_F3		EQU	106
KEY_ALT_F4		EQU	107
KEY_ALT_F5		EQU	108
KEY_ALT_F6		EQU	109
KEY_ALT_F7		EQU	110
KEY_ALT_F8		EQU	111
KEY_ALT_F9		EQU	112
KEY_ALT_F10		EQU	113
KEY_ALT_F11		EQU	139
KEY_ALT_F12		EQU	140

KEY_BS			EQU	14
KEY_TAB 		EQU	15
KEY_INS 		EQU	82
KEY_DEL 		EQU	83

KEY_CTRL_TAB		EQU	148
KEY_CTRL_INS		EQU	146
KEY_CTRL_DEL		EQU	147

KEY_ALT_INS		EQU	162
KEY_ALT_DEL		EQU	163

KEY_MINUS		EQU	74
KEY_PLUS		EQU	78
KEY_MULTIPLY		EQU	55
KEY_DIVIDE		EQU	224

KEY_CTRL_MINUS		EQU	142
KEY_CTRL_PLUS		EQU	144
KEY_CTRL_MULTIPLY	EQU	150
KEY_CTRL_DIVIDE 	EQU	149

KEY_ALT_DIVIDE		EQU	164

KEY_ENTER		EQU	28

KEY_GRAY_ENTER		EQU	224
KEY_ALT_GRAY_ENTER	EQU	166

KEY_Q			EQU	16
KEY_W			EQU	17
KEY_E			EQU	18
KEY_R			EQU	19
KEY_T			EQU	20
KEY_Y			EQU	21
KEY_U			EQU	22
KEY_I			EQU	23
KEY_O			EQU	24
KEY_P			EQU	25
KEY_AA			EQU	26

KEY_A			EQU	30
KEY_S			EQU	31
KEY_D			EQU	32
KEY_F			EQU	33
KEY_G			EQU	34
KEY_H			EQU	35
KEY_J			EQU	36
KEY_K			EQU	37
KEY_L			EQU	38
KEY_OE			EQU	39
KEY_AE			EQU	40

KEY_Z			EQU	44
KEY_X			EQU	45
KEY_C			EQU	46
KEY_V			EQU	47
KEY_B			EQU	48
KEY_N			EQU	49
KEY_M			EQU	50

KEY_1			EQU	2
KEY_2			EQU	3
KEY_3			EQU	4
KEY_4			EQU	5
KEY_5			EQU	6
KEY_6			EQU	7
KEY_7			EQU	8
KEY_8			EQU	9
KEY_9			EQU	10
KEY_0			EQU	11

KEY_ALT_1		EQU	120
KEY_ALT_2		EQU	121
KEY_ALT_3		EQU	122
KEY_ALT_4		EQU	123
KEY_ALT_5		EQU	124
KEY_ALT_6		EQU	125
KEY_ALT_7		EQU	126
KEY_ALT_8		EQU	127
KEY_ALT_9		EQU	128
KEY_ALT_0		EQU	129

; Modes for keys, these must each have their own bits! i.e they must all
; be powers of 2

MODE_TEXTVIEW		EQU	01h
MODE_HEXMODE		EQU	02h
MODE_DUMPVIEW		EQU	04h
MODE_CODEMODE		EQU	08h

MODE_FIRSTVIEW		EQU	01h
MODE_LASTVIEW		EQU	08h
MODE_LASTVIEWNUMBER	EQU	4	; 1;2;3;4 etc
MODE_GLOBAL		EQU	0fh	; all modes


; Functionnumbers for user-callable functions

DO_FIRSTBYTE		EQU	0
DO_LASTBYTE		EQU	1
DO_TOGGLEFIELD		EQU	2
DO_BACKSPACE		EQU	3
DO_LEFT 		EQU	4
DO_RIGHT		EQU	5
DO_UP			EQU	6
DO_DOWN 		EQU	7
DO_PAGEUP		EQU	8
DO_PAGEDOWN		EQU	9
DO_TOGGLEINSERT 	EQU	10
DO_DELETEBYTE		EQU	11
DO_CUT			EQU	12
DO_COPY 		EQU	13
DO_PASTE		EQU	14
DO_ONLINEHELP		EQU	15
DO_SAVE 		EQU	16
DO_CHOOSEFILE		EQU	17
DO_SELECTMODE		EQU	18
DO_GOTO 		EQU	19
DO_SELECTLF		EQU	20
DO_SEARCH		EQU	21
DO_REPLACE		EQU	22

DO_SELECTALL		EQU	23
DO_COMPARENEXT		EQU	24
DO_GOTOLINE		EQU	25
DO_LOADFILE		EQU	26
DO_FINDNEXT		EQU	27
DO_PARAUP		EQU	28
DO_PARADOWN		EQU	29
DO_DECOFFSET		EQU	30
DO_INCOFFSET		EQU	31
DO_KILOBYTEUP		EQU	32
DO_KILOBYTEDOWN 	EQU	33
DO_CHOOSEVIDEOMODE	EQU	34
DO_COMPARE		EQU	35
DO_SETUP		EQU	36

DO_SETMARKER		EQU	37
DO_HELP 		EQU	38
DO_INSERTBYTE		EQU	39
DO_NEXTFILE		EQU	40
DO_PREVFILE		EQU	41
DO_TOGGLESPLITSCREEN	EQU	42
DO_UNMARK		EQU	43
DO_TOGGLEACTIVEWINDOW	EQU	44
DO_EXIT 		EQU	45

DO_NOP			EQU	46

DO_FIRSTLINE		EQU	47
DO_LASTLINE		EQU	48
DO_TEXTLEFT		EQU	49
DO_TEXTRIGHT		EQU	50
DO_TEXTUP		EQU	51
DO_TEXTDOWN		EQU	52
DO_256BYTESUP		EQU	53
DO_256BYTESDOWN 	EQU	54
DO_WRAP 		EQU	55
DO_EXEHEADER		EQU	56
DO_4PAGESUP		EQU	57
DO_4PAGESDOWN		EQU	58

DO_TOGGLENIBBLEMOVE	EQU	59

DO_RENAMEFILE		EQU	60
DO_QUITFILE		EQU	61

DO_TEMP 		EQU	62	; just for use inside keysetup

DO_SELECTLEFT		EQU	63
DO_SELECTRIGHT		EQU	64
DO_SELECTUP		EQU	65
DO_SELECTDOWN		EQU	66
DO_SELECT256BYTESUP	EQU	67
DO_SELECT256BYTESDOWN	EQU	68
DO_SELECTKILOBYTEUP	EQU	69
DO_SELECTKILOBYTEDOWN	EQU	70
DO_SELECTFIRSTBYTE	EQU	71
DO_SELECTLASTBYTE	EQU	72

DO_INSERTVALUE		EQU	73
DO_SETUPKEYS		EQU	74

DO_DUMPVIEWFIRSTBYTE	EQU	75
DO_DUMPVIEWLASTBYTE	EQU	76
DO_DUMPVIEWUP		EQU	77
DO_DUMPVIEWDOWN 	EQU	78
DO_DUMPVIEWLEFT 	EQU	79
DO_DUMPVIEWRIGHT	EQU	80
DO_DUMPVIEWPAGEUP	EQU	81
DO_DUMPVIEWPAGEDOWN	EQU	82
DO_DUMPVIEW4PAGESUP	EQU	83
DO_DUMPVIEW4PAGESDOWN	EQU	84
DO_DUMPVIEWGOTO 	EQU	85
DO_DEFINEMASK		EQU	86
DO_TOGGLEMASK		EQU	87

DO_SETTABSIZE		EQU	88

DO_CODEVIEWUP		EQU	89
DO_CODEVIEWDOWN 	EQU	90
DO_TOGGLESEGSIZE	EQU	91
DO_CODEVIEWINIT 	EQU	92
DO_CODEVIEWLEFT 	EQU	93
DO_CODEVIEWRIGHT	EQU	94
DO_CODEVIEWPAGEUP	EQU	95
DO_CODEVIEWPAGEDOWN	EQU	96
DO_CMDECOFFSET		EQU	97
DO_CMINCOFFSET		EQU	98
DO_CMSCRUP		EQU	99
DO_CMSCRDOWN		EQU    100
DO_CMHOME		EQU    101
DO_CMEND		EQU    102
DO_CM4PAGESUP		EQU    103
DO_CM4PAGESDOWN 	EQU    104
DO_CMDELETEBYTE 	EQU    105
DO_CMBACKSPACE		EQU    106
DO_CMGOTO		EQU    107
DO_CMCOMMENTS		EQU    108

DO_VIEWMODETEXT 	EQU    109
DO_VIEWMODEHEX		EQU    110
DO_VIEWMODEDUMP 	EQU    111
DO_VIEWMODECODE 	EQU    112
DO_NEXTVIEWMODE 	EQU    113
DO_PREVVIEWMODE 	EQU    114

DO_SETOFFSET1		EQU    115
DO_SETOFFSET2		EQU    116
DO_SETOFFSET3		EQU    117
DO_SETOFFSET4		EQU    118
DO_SETOFFSET5		EQU    119
DO_SETOFFSET6		EQU    120
DO_SETOFFSET7		EQU    121
DO_SETOFFSET8		EQU    122
DO_SETOFFSET9		EQU    123
DO_GETOFFSET1		EQU    124
DO_GETOFFSET2		EQU    125
DO_GETOFFSET3		EQU    126
DO_GETOFFSET4		EQU    127
DO_GETOFFSET5		EQU    128
DO_GETOFFSET6		EQU    129
DO_GETOFFSET7		EQU    130
DO_GETOFFSET8		EQU    131
DO_GETOFFSET9		EQU    132
DO_PUSHOFFSET		EQU    133
DO_POPOFFSET		EQU    134

DO_TOGGLEMACROREC	EQU    135
DO_PLAYMACRO		EQU    136

DO_TEXTMULTILEFT	EQU    137
DO_TEXTMULTIRIGHT	EQU    138

DO_ASSEMBLE		EQU    139

DO_PUTSEL		EQU    140
DO_CALCIT		EQU    141
DO_GETBLK		EQU    142

MAX_FUNCTION		EQU    142	; the highest DO_* function number!


;
; M a c r o s 
;

;waitkey 	macro
;	push	eax
;	movzx	eax,v86r_ax
;	push	eax
;	mov	v86r_ah,0
;	mov	al,16h
;	int	33h
;	pop	eax
;	mov	v86r_ax,ax
;	pop	eax
;endm

;
;putch		macro	char
;	push	eax
;	movzx	eax,v86r_ax
;	push	eax
;	mov	v86r_al,char
;	mov	al,29h
;	int	33h
;	pop	eax
;	mov	v86r_ax,ax
;	pop	eax
;endm

;
;beep		macro
;	push	eax
;	movzx	eax,v86r_ax
;	push	eax
;	mov	v86r_al,7
;	mov	al,29h
;	int	33h
;	pop	eax
;	mov	v86r_ax,ax
;	pop	eax
;endm

